

import time


class Counter(object):

  nb_calls = {}
  
  @staticmethod
  def count(func):
      """Count the numbers of call of each function tagged with count."""
      def wrapper(*arg, **args):
        old_val = Counter.nb_calls.setdefault(func.func_name, 0)
        Counter.nb_calls[func.func_name]= old_val + 1
        return  func(*arg, **args)
      return wrapper

def profile(func):
  """A decorator use to profile functions.
  
  The lag of the function is printed out in stdout."""
  def wrapper(*arg, **args):
    start = time.time()
    res =  func(*arg, **args)
    print (time.time() - start) * 1000, 'millisec'
    return res
  return wrapper
